#define USE_HTML_STATUS
#define USE_HTML_PROMPT

#include <advr.t>
#include <gameinfo.t>
#include "stdrm.t"
#include <errorru.t>

#include <spellchecker.t>
#include "flint.t" //  advr.t

#include "p&o.t"

#include "money.t" //  
#include "me.t"    //   
#include "compshop.t" // " "       (startroom)
#include "street.t" //  ""     
#include "busstop.t" //    
#include "foodshop.t"  // 
#include "house.t"  // ,   

replace commonInit: function
{"\H+";}

getGameInfo: function
{
    return ['Name', '',
            'Byline', ' -   (nadvoretrava@mail.ru)',
            'Desc', '          ,  
                   .        -
              .',
            'Version', '1.0',
            'ReleaseDate', getGameInfoToday(),
            'Language', 'RU'];
}

//  ,   
game : object
    massacre = nil  //  -,  true -  
    killTurns = 0   // 
    mute = nil      // mute ,     (      ..)
    secretEnd = nil //   
    winSecret = nil // 
    
    waitVerbCount = 0
    
    startBlood =
    {
      if (self.massacre) exit;
      
      self.massacre := true;
      notify(startroom, &alert, 0);
      
      if (Timofei.location = Me.location)
      {
        if (CompSeller.distracted = true)
        {
          CompSeller.distracted := nil;
          unnotify(Timofei, &distractCompSeller);
          notify(Timofei, &followMe);
          Timofei.followsMe := true;
          "\b       .     . ";
        }
        else
        {
          "\b,      - ,   ,    
             . ";
        }
        Timofei.shocked := true;
      }
            
      unnotify(CompSeller, &diarrhea);
    }
;

//   
modify thing
    verDoAwake(actor) = {"<<ZAG(self, &sdesc)>>   . ";}
    verDoSpit(actor) = {"<<ZAG(self, &sdesc)>>  ! ";}
    verDoBuy(actor) = 
    {
      if (Me.location != startroom && 
          Me.location != shop)
        "    ,      -. ";
      else
        if (self = CompSeller || self = MobileSeller || self = FoodSeller)
          "<<ZAG(self, &sdesc)>>   (  )! ";
        else
          "<<ZAG(self, &sdesc)>>   (  )! ";
    }
    verDoAttack(actor) = {"  <<self.vdesc>>      . "; }
    verDoSteal(actor) = {" <<self.vdesc>>    . ";}
    verDoBreak(actor) = {" <<self.vdesc>>    . ";}
    verDoBreakWith(actor, iobj) = { self.verDoBreak(actor); }
    verDoDistract(actor) = 
    { 
      if (isclass(self, Actor))
      {
        if (actor = parserGetMe())
          "         ( ). ";
      }
      else
      {
        "   -  . ";
      }
    }
    verDoClean(actor) = {"    <<self.vdesc>>,       . ";}
    verDoHelpMe(actor) = {" ,      <<self.ddesc>>. ";}
    verDoCall(actor) = {"<<ZAG(self, &sdesc)>>   . ";}
    verDoCallWith(actor) = { self.verDoCall(actor); }
    verIoCallWith(actor, dobj) = { "     <<dobj.rdesc>>  <<self.tdesc>>. "; }
    verDoAssemble(actor) = { "<<ZAG(self, &sdesc)>>     . "; }
    verDoPlay(actor) = { "  <<self.pdesc>>   . "; }
;

//  
modify Actor
    verDoAwake(actor) = {"<<ZAG(self, &sdesc)>>    ! ";}
;

spitVerb : deepverb
    verb = '' ''
    sdesc = ""
    
    doAction = 'Spit'
;


class metal : item
    //  , -        
    doTake(actor) = 
    {
      if (not Me.metalTaker)
      {
        "-    ,  <<self.vdesc>>  . ";
        Me.metalTaker := true;
      }
      else
      {
        "   !      ,    .
          . ";
      }
      return nil;
    }
;

shopstreet : street
    sdesc = "<b></b>"
    ldesc = 
    {
      "      .      &#8212; 
             .    .
               &laquo;&raquo;.  ,  ,
         . ";
       
       if (tshirt.isworn = nil)
         "     . ";
    }
    isHer = true
    
    north = startroom
    west = shop
    east = busstop1
    south =
    {
      if (not Me.withoutMoney)
      {
        "     ? ";
      }
      else
      {
        if (bomj.followsMe)
        {
        " ,    . ";
         
         bomj.moveInto(busstop1);
         unnotify(bomj, &followMe);
        }
        
       " ,   ,    &#8212;      
        .  .\b";
        return busstop2;        
      }
    }
    
    noexit = "     . "
;

foodsign : decoration
	location = shopstreet
	sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "   :  Coca-Cola &#8212;  &#8212;  Coca-Cola. ,   , 
                &laquo; &raquo;. "
    isHer = true
;

urn : qcontainer, metal
    location = shopstreet
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    ldesc = "  . . "
    isHer = true
    isListed = nil   
;

newspaper : readable
    location = urn
    sdesc = ""
    rdesc = ""
    ddesc = ""
    vdesc = ""
    tdesc = ""
    pdesc = ""
    noun = '' '' '' '' '' '' '#d' '#t' '#t'
    adjective = '' '#t' '' '#d' '#t' '' ''
    ldesc = "     &laquo; &raquo;. "
    readdesc = " ,    ,      
                     .      ,  
                     .      ,  
               ,        .   
                    .        
                      . "
    isHer = true
;