//v0.7 
//(c) by Flint, 2008

modify Actor
	_places = []
	_objects = []
;

placesVerb : darkVerb
	verb = '' '' ''
	sdesc = ""
	
	action(actor) =
	{
		local i, len, places;
		
		places := parserGetMe()._places;
					
		//"\H-";
		
		len := length(places);
		
		if (len > 0)
		{
			"<<ZAG(parserGetMe(), &sdesc)>> ";
			if (parserGetMe().isThem) "";
			"  : ";
			
			for (i := 1; i < len; i++)
			{
				say( room2str(places[i], &vdesc) );
				if (i != len - 1) ", ";
				else "  ";
			}
		
			"<<room2str(places[len], &vdesc)>>.";	
		}
		else
		{
			"<<ZAG(parserGetMe(), &sdesc)>>    <<iao(parserGetMe())>>. ";
		}
		
		//"\H+";
	}
	
;

objectsVerb : darkVerb
	verb = '' '' ''
	sdesc = ""
	
	action(actor) =
	{
		local i, co, objects;
		
		objects := parserGetMe()._objects;
		
		if ( length(objects) = 0 )
		{
			" <<parserGetMe().rdesc>>     . ";
			return;
		}
		
		",  <<parserGetMe().sdesc>> <<parserGetMe().isThem?'':''>>:\n";
		
		for (i := 1; i <= length(objects); i++)
		{
			co := objects[i];
			
			"\ \ \ <<co.sdesc>> ";
			if ( isinside(co, parserGetMe()) )
				if ( co.isworn )
					"(<<yao(co)>>)";
				else
					"(<<glok(parserGetMe(), 1, 2)>>)";
			else if ( co.lastSeen = nil )
				"(<<iao(co)>>)";
			else if ( proptype(co, &lastSeen) = 2 )
			{
				"(";
				if (co.lastSeenRoom != nil)
					"<<room2str(co.lastSeenRoom, &sdesc)>>, ";
				"<<co.lastSeenPrep>><<room2str(co.lastSeen, co.lastSeenCase)>>)";
			}
			
			"\n";
		}
	}
;

modify room
	firstseen =
	{
		if ( find(parserGetMe()._places, self) = nil )
			parserGetMe()._places += self;
		pass firstseen;
	}
;

modify item
	lastSeen = nil
	lastSeenPrep = ''
	lastSeenCase = &sdesc
	lastSeenRoom = nil

	moveInto(obj) =
	{	
		if (obj = parserGetMe())
		{
			if ( find(parserGetMe()._objects, self) = nil )
				parserGetMe()._objects += self;
		}
		else if ( (obj = nil || parserGetMe().isVisible(obj)) && self.isVisible(parserGetMe()) )
		{
			// ,    
			local loc := obj;			
			
			while (loc != nil && loc.location != nil)
				loc := loc.location;
			
			if (loc != obj)	
				self.lastSeenRoom := loc;
			
			inherited.moveInto(obj);
			
			if (self.isVisible(parserGetMe()))
				self.lastSeen := obj;
			else
				self.lastSeen := nil;

			
			if ( isclass(obj, movableActor) )
			{
				self.lastSeenPrep := ' ';
				self.lastSeenCase := &rdesc;
				self.lastSeenRoom := nil;
			}
			else if ( parserGetObj(PO_PREP) = inPrep )
			{
				self.lastSeenPrep := ' ';
				self.lastSeenCase := &pdesc;
			}
			else if ( parserGetObj(PO_PREP) = onPrep )
			{
				self.lastSeenPrep := ' ';
				self.lastSeenCase := &pdesc;
			}
			
			return;
		}

		pass moveInto;	
	}
;

initPO : function
{
	parserGetMe()._places += startroom;
	parserGetMe()._objects += parserGetMe().contents;
}

room2str : function(room, ptr)
{
	local desc := dToS(room, ptr);
	desc := removeTags(desc);
	desc := lowerRoom(desc);
	return desc;
}

removeTags : function(str)
{
	local res;
	
	while (res := reSearch('<[^>]+>', str))
	{
		str := substr(str, 1, res[1] - 1) + substr(str, res[1] + res[2], length(str));
	}
	
	return str;
}

lowerRoom : function(desc)
{
	desc := loweru(substr(desc, 1, 1)) + substr(desc, 2, length(desc));
	return desc;
}

replace isinside: function(item,loc)
{
	if (item.location=loc) return(true);
	else if (item.location) return(isinside(item.location,loc)); 
	else return(nil);
}