replace sayPrefixCount: function(cnt, obj)
{
	say(['' '' '' '' ''
	'' '' '' '' ''
	'' '' '' '' ''
	'' '' '' '' ''][cnt]);
};

modify decoration
    message = {ZAG(self,&sdesc);"  "; glok(self,1,1); " . ";}
    ldesc = {self.message;}
    
    allowAsk = nil
    
    dobjGen(a, v, i, p) =
    {
        if (v <> inspectVerb && v <> osmVerb)
        {
            self.message;
            exit;
        }
    }
    iobjGen(a, v, d, p) =
    {
    	if (v <> askVerb || not self.allowAsk)
    	{
    		if (isinside(self, Me.location))
    		{
        		self.message;
        		exit;
        	}
        	else
        	{
        		ZAG(self,&sdesc);"  "; glok(self,1,1); " . ";
        		exit;
        	}        	
        }
    }
;

replace preparse: function(comStr)
{
    local str;
    
    comStr:=TrimLeft(comStr);

    //     "*"  ">",    -  
    if (substr(comStr,1,1)='*' or substr(comStr,1,1)='>') return nil;

    if (comStr!='') 
     {
      comStr:=loweru(comStr);
      comStr:=dezyo(comStr);
     }

    if (comStr='') return '';
    
    //"  " -> ", "
    comStr := preparseTell(comStr);
       
    // 
    comStr := checkString(comStr);
    
    checkWait(comStr);
    
    return comStr;
};

replace preparseExt: function(actor, verb, str, typ)
{
    local comStr, ret; 
    comStr:=str;

    comStr:=TrimLeft(comStr);

    //     "*"  ">",    -  
    if (substr(comStr,1,1)='*' or substr(comStr,1,1)='>') return nil;
 
     if (comStr!='') 
      {
        comStr:=loweru(comStr);
        comStr:=dezyo(comStr);
      }

     if (comStr='') return '';

     if (loweru(substr(comStr, 1, 3)) = ' ')
         return 'oops ' + substr(comStr, 3, length(comStr) - 2);
     ret := reSearch('',comStr);
     if (ret!=nil)
      {
       comStr:=substr(str,1,ret[1]-1);
       comStr:=comStr+' '+dToS(parserGetObj(PO_ACTOR),&sdesc);
       comStr:=comStr+' ';
       comStr:=comStr+substr(str,ret[1]+ret[2],length(str));
      }
     //    .
     ret := reSearch('(^[ ]|^[ ]|^[ ]|^[ ]|^[ ]|^[ ]|^[ ]|^[ ]|^[ ])',comStr);
     if (ret!=nil) return substr(comStr, ret[1]+ret[2], length(comStr));
     
     //   
     comStr := checkString(comStr);
     
     if (comStr=str) return true;
     return comStr;
};

replace HelpVerb: sysverb
    verb = 'help' ''
    sdesc = ""
    action(actor) = {
"<b> </b>\n
\t       ,  ,    .  ,     \">\"     ,  ,      .  , ,  ,        !  ,        ,   ,   .\b
 
<b> </b>\n
\t        \"<i></i>\".       ,    ,        ,     ,    ,  \"<i>  </i>\".      \"<i></i>\",     \"<i>  </i>\".     \"<i></i>\",    ,   .\n\t

    -   .   ,          (\"      .      \"). ,     ,    \"<i>   </i>\",   \"<i>  </i>\",   \"<i></i>\",     -  \"<i></i>\". ,    \"<i></i>\", \"<i></i>\", \"<i></i>\", \"<i></i>\" ( ), \"<i></i>\", \"<i></i>\"  \"<i></i>\".       \"<i></i>\" ( \"<i></i>\")  \"<i></i>\" ( \"<i></i>\"). ,     - \"<i></i>\"  \"<i></i>\".    -    ,    ,            .       ,   (\"<i></i>\").        ,   \"<i></i>\",      .     \"<i></i>\".\n\t

,          \"<i></i>\" ( \"<i></i>\").       \"<i></i>\" (  \"<i></i>\").\n\t

      ,   ,   . ,           . , ,   ,     ,        .    ,         .          , ,  ,      .      .\n\t

  ,     ,            \"    -\".  ,               .       ,          , ,  ,       (   ) .\b

<b>   </b>\n
\t ,             ,   .         .          .      , :\b

\t<i></i>\n
\t<i></i>\n
\t<i></i>\n
\t ..\b

      , :\b

\t<i>  </i>\n
\t<i> </i>\n
\t<i> </i>\n
\t<i> </i>\n
\t<i> </i>\n
\t<i> </i>\n
\t<i>  </i>\n
\t<i>  </i>\n
\t<i>  </i>\n
\t<i> </i>\b


\t     .   ,     ,    - ,      . , \"<i>   </i>\" -  ,  \"<i>   </i>\",    , ,  ,   .\n\t
  () :\b

\t<i>   </i>\n
\t<i>   </i>\n
\t<i>  -</i>\n
\t<i>  </i>\n
\t<i>   4 </i>\n
\t<i>  </i>\n
\t<i>  </i>\n
\t<i> \"\"  </i>\n
\t<i>  </i>\b

     ,     :\b

 \t> \n
 \t     :     ?\b

       (<i>  </i>),    :\b

 \t> \n
 \t     :     ?\n
 
 \t>\n
 \t.\b

       .\b

\t<i> ,   </i>\n
\t<i> </i> (         ,     )\n
\t<i>   </i>\n
\t<i> ,  </i>\n
\t<i>        </i>\b

<b>   </b>\n
\t       : \"<i></i>\"  \"<i></i>\" (   ). :\b

\t<i>   </i>\n
\t<i>   </i>\n
\t<i>   </i>\n
\t<i>   </i>\n
\t<i>   </i>\n
\t<i>   </i>\b

\t    .    <i></i>  <i></i>      (  + ).    \"<i>     </i>\",   \"<i>   </i>\".\n\t

      (  , )   \"<i> , </i>\". :\b

\t<i>,  </i>\n
\t<i>,  </i>\n
\t<i>,    </i>\n
\t<i>,   .  .   </i>\b

\t           . ,   ,   ,        ,    .\n\t

    -    \"<i></i>\"  \"<i></i>\"  - . , \"<i>  </i>\".\b

<b> </b>\n
\t<i></i>, <i></i> -  
 \n
\t<i></i> -    \n
\t<i></i> - \n
\t<i></i> -    ()  \n
\t<i></i> -   \n
\t<i></i> -     \n
\t<i></i> -   \n
\t<i></i> -   \n
\t<i></i> -   \n
\t<i></i> (<i></i>) -     .  \"\"          .\n
\t<i></i> -     ( -   )\n
\t<i></i> -          .    ,     : &laquo;    \"\".&raquo;             &laquo; &raquo;.\n
\t<i></i> (  <i></i>) -   \b

  !";

    }
;

replace parseDefaultExt: function(actor, verb, obj, prp)
  {
    "(";
    if (prp = nil) 
      {
       if (verb.pred) "<<verb.pred.sdesc>> ";
       if (verb.parsdef) obj.(verb.parsdef);
       else obj.vdesc;
      } 
    else
     {
    if (!(prp=toPrep && obj.isactor)) {prp.sdesc;" ";} }
    if (prp = atPrep or prp = inPrep) obj.vdesc;
    if (prp = withPrep) obj.rdesc;
    if (prp = overPrep) obj.tdesc;
    if (prp = onPrep) obj.pdesc;
    if (prp = offPrep or prp = fromPrep or prp = outPrep) obj.rdesc;
    if (prp = toPrep) obj.ddesc;
    ")\n";
  }
